// Importing libraries essentials for the phone
import processing.phone.*; // import phone library to go fullscreen
Phone myPhone;             // named reference to phone instance

//   **************************************
//   *                                    *
//   * Snowball_Menu navigation_Prototype *
//   *                                    *
//   **************************************
//
//    I    IUAV - Istituto Universitario di Architettura di Venezia
//   ---   Faculty of design and arts fDA, clasVEM
//    U    IxD Lab 1_2007-08, Laboratorio di comunicazione visuale e cinetica
//   ---   professors: Gillian Crampton Smith, Philip Tabor
//    A    students: Andrea Collet 263367, Maria Chiara Toncich 261507
//   ---
//    V    http://www.iuav.it - http://www.interaction-venice.com
// 
//         ------------
// 
//         Mode-switching system for screen change has been
//         developed by Nicholas Zambetti



////////////////////////////////////////////////////////////////////
// SCREENS DECLARATION AND DRAWING
////////////////////////////////////////////////////////////////////
// Names of the modes are given to match the image they are linked to.
int MODE_SNOWBALL00 = 0;
int MODE_SNOWBALL01 = 1;
int MODE_SNOWBALL01_1 = 2;
int MODE_SNOWBALL01_2 = 3;
int MODE_SNOWBALL01_3 = 4;
int MODE_SNOWBALL02_1 = 5;
int MODE_SNOWBALL02_2 = 6;
int MODE_SNOWBALL03_1 = 7;
int MODE_SNOWBALL03_2 = 8;
int MODE_SNOWBALL03_3 = 9;
int MODE_SNOWBALL04_1 = 10;
int MODE_SNOWBALL04_2 = 11;
int MODE_SNOWBALL04_3 = 12;
int MODE_SNOWBALL04_4 = 13;
int MODE_SNOWBALL04_5 = 14;
int MODE_SNOWBALL05_1 = 15;
int MODE_SNOWBALL05_2 = 16;
int MODE_SNOWBALL06 = 17;
int MODE_SNOWBALL06_1 = 18;

// Giving to the 'mode' variable the initial value of
// 'MODE_SNOWBALL_00' we start the application with the
// title screen.
int mode = MODE_SNOWBALL00;

// Here all the image placeholders are declared.
PImage bgsnowball00;
PImage bgsnowball01;
PImage bgsnowball01_s1;
PImage bgsnowball01_s2;
PImage bgsnowball01_s3;
PImage bgsnowball02_s1;
PImage bgsnowball02_s2;
PImage bgsnowball03_s1;
PImage bgsnowball03_s2;
PImage bgsnowball03_s3;
PImage bgsnowball04_s1;
PImage bgsnowball04_s2;
PImage bgsnowball04_s3;
PImage bgsnowball04_s4;
PImage bgsnowball04_s5;
PImage bgsnowball05_s1;
PImage bgsnowball05_s2;
PImage bgsnowball06;
PImage bgsnowball06_s1;


// Function that loads all the images.
void loadImages()
{
  bgsnowball00 = loadImage("bg_snowball00.png");
  bgsnowball01 = loadImage("bg_snowball01.png");
  bgsnowball01_s1 = loadImage("bg_snowball01_selected1.png");
  bgsnowball01_s2 = loadImage("bg_snowball01_selected2.png");
  bgsnowball01_s3 = loadImage("bg_snowball01_selected3.png");
  bgsnowball02_s1 = loadImage("bg_snowball02_selected1.png");
  bgsnowball02_s2 = loadImage("bg_snowball02_selected2.png");
  bgsnowball03_s1 = loadImage("bg_snowball03_selected1.png");
  bgsnowball03_s2 = loadImage("bg_snowball03_selected2.png");
  bgsnowball03_s3 = loadImage("bg_snowball03_selected3.png");
  bgsnowball04_s1 = loadImage("bg_snowball04_selected1.png");
  bgsnowball04_s2 = loadImage("bg_snowball04_selected2.png");
  bgsnowball04_s3 = loadImage("bg_snowball04_selected3.png");
  bgsnowball04_s4 = loadImage("bg_snowball04_selected4.png");
  bgsnowball04_s5 = loadImage("bg_snowball04_selected5.png");
  bgsnowball05_s1 = loadImage("bg_snowball05_selected1.png");
  bgsnowball05_s2 = loadImage("bg_snowball05_selected2.png");
  bgsnowball06 = loadImage("bg_snowball06.png");
  bgsnowball06_s1 = loadImage("bg_snowball06_selected1.png");
  
}


////////////////////////////////////////////////////////////////////
// WAIT FUNCTION
////////////////////////////////////////////////////////////////////
// This function takes a value in milliseconds and makes the device
// wait the equivalent time. Variable 'mswait' brings this value,
// which is added to the current milliseconds to obtain 'currenTime'.
// The application waits until the milliseconds reach the value of
// 'currenTime'.
void wait(int msWait)
{
  int currentTime = millis() + msWait;
  while(millis() < currentTime){}
  
}


/////////////////////////////////////////////////////////////////////
// DRAWSCREEN FUNCTION
/////////////////////////////////////////////////////////////////////
// This function reads the current mode and stores is into the variable
// 'screenNr', which is used to display a certain screen according with
// the value.
void drawScreen(int screenNr, int x, int y)
{
  switch(screenNr)
  {
  case 0:
    image(bgsnowball00, x, y);
    break;
  case 1:
    image(bgsnowball01, x, y);
    break;
  case 2:
    image(bgsnowball01_s1, x, y);
    break;
  case 3:
    image(bgsnowball01_s2, x, y);
    break;
  case 4:
    image(bgsnowball01_s3, x, y);
    break;
  case 5:
    image(bgsnowball02_s1, x, y);
    break;
  case 6:
    image(bgsnowball02_s2, x, y);
    break;
  case 7:
    image(bgsnowball03_s1, x, y);
    break;
  case 8:
    image(bgsnowball03_s2, x, y);
    break;
  case 9:
    image(bgsnowball03_s3, x, y);
    break;
  case 10:
    image(bgsnowball04_s1, x, y);
    break;
  case 11:
    image(bgsnowball04_s2, x, y);
    break;
  case 12:
    image(bgsnowball04_s3, x, y);
    break;
  case 13:
    image(bgsnowball04_s4, x, y);
    break;
  case 14:
    image(bgsnowball04_s5, x, y);
    break;
  case 15:
    image(bgsnowball05_s1, x, y);
    break;
  case 16:
    image(bgsnowball05_s2, x, y);
    break;
  // case 17 is a passage from a screen to another with a delay in
  // between. When confirming to save the snowball as snowball at-
  // tack the applications shows first the screen SETTING... for
  // 800 millisecons, then changes to the COMPLETED! screen.
  // In order to make this function work properly, the wait() recall
  // must be written at the beginning of the case which the dealyed
  // image belongs to, and not at the end of the case where the
  // delay starts.
  case 17:
    image(bgsnowball06, x, y);
    mode = MODE_SNOWBALL06_1;
    break;
  case 18:
    wait(800);
    image(bgsnowball06_s1, x, y);
    break;
    
  }
}


////////////////////////////////////////////////////////////////////
// SETUP FUNCTION
////////////////////////////////////////////////////////////////////
void setup()
{
  myPhone = new Phone(this); // create new phone instance/controller
  myPhone.fullscreen();      // tell phone to go fullscreen

  loadImages(); // load images
}


////////////////////////////////////////////////////////////////////
// DRAW FUNCTION
////////////////////////////////////////////////////////////////////
// This function happens repeatedly (according to framerate)
void draw()
{
  drawScreen(mode, 0, 0);
}


////////////////////////////////////////////////////////////////////
// KEYPRESSED FUNCTION
////////////////////////////////////////////////////////////////////
// This function happens whenever a key is pressed
// and makes the value of variable "mode" change
// according the button which is pressed
void keyReleased()
{
  
// Conditions to exit or to restart the application
  if(keyCode == '9'){ // Hit 9 to directly exit the program
    exit();
  }
  if(keyCode == '7'){ // Hit 7 to directly come back to the start
    mode = MODE_SNOWBALL00;
  }

// Changes 'mode' value according to the key that is pressed.
//
// -6 and -7 values used on the cases below are the values
// respectively of Softbutton-Left and Softbutton-Right.
  switch(mode)
  {
    case 0: // We are on the title screen
      if(keyCode == -7){
        mode = MODE_SNOWBALL01_1;
      }
      break;
    case 1: // This is the waiting screen which doesn't appear in this prototype
      if(keyCode == -6){
        mode = MODE_SNOWBALL01_1;
      }
      break;
    case 2: // MAIN MENU screen on its first appearance, snowball is focused
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL02_1;
      }else if(keyCode == DOWN){
        mode = MODE_SNOWBALL01_2;
      }else if(keyCode == RIGHT){
        mode = MODE_SNOWBALL01_3;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL01;
      }
    case 3: // MAIN MENU screen with profile focused
      if(keyCode == UP){
        mode = MODE_SNOWBALL01_1;
      }else if(keyCode == RIGHT){
        mode = MODE_SNOWBALL01_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL01;
      }
    case 4: // MAIN MENU screen with contact list focused
      if(keyCode == LEFT){
        mode = MODE_SNOWBALL01_1;
      }else if(keyCode == DOWN){
        mode = MODE_SNOWBALL01_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL01;
      }
      break;
    case 5: // SNOWBALL MENU screen with add image focused 
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL03_1;
      }else if(keyCode == RIGHT){
        mode = MODE_SNOWBALL02_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL01_1;
      }
      break;
    case 6: // SNOWBALL MENU screen with add sound focused
      if(keyCode == LEFT){
        mode = MODE_SNOWBALL02_1;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL01_1;
      }
      break;
    case 7: // PREFERENCES of the image screen with FROM ARCHIVE focused
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL04_1;
      }else if(keyCode == DOWN){
        mode = MODE_SNOWBALL03_2;
      }else if(keyCode == RIGHT){
        mode = MODE_SNOWBALL03_3;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL02_1;
      }
      break;
    case 8: // PREFERENCES of the image screen with FROM CAMERA focused
      if(keyCode == UP){
        mode = MODE_SNOWBALL03_1;
      }else if(keyCode == RIGHT){
        mode = MODE_SNOWBALL03_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL02_1;
      }
      break;
    case 9: // PREFERENCES of the image screen with DOWNLOAD focused
      if(keyCode == LEFT){
        mode = MODE_SNOWBALL03_1;
      }else if(keyCode == DOWN){
        mode = MODE_SNOWBALL03_3;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL02_1;
      }
      break;
    case 10: // ARCHIVE screen with the top-left icon focused
      if(keyCode == DOWN){
        mode = MODE_SNOWBALL04_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL03_1;
      }
      break;
    case 11: // ARCHIVE screen with the chocolate-tree icon focused
      if(keyCode == RIGHT){
        mode = MODE_SNOWBALL04_3;
      }else if(keyCode == UP){
        mode = MODE_SNOWBALL04_1;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL03_1;
      }
      break;
    case 12: // ARCHIVE with the chocolate house focused
      if(keyCode == RIGHT){
        mode = MODE_SNOWBALL04_4;
      }else if(keyCode == LEFT){
        mode = MODE_SNOWBALL04_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL03_1;
      }
      break;
    case 13: // ARCHIVE with the flower focused
      if(keyCode == RIGHT){
        mode = MODE_SNOWBALL04_5;
      }else if(keyCode == LEFT){
        mode = MODE_SNOWBALL04_3;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL03_1;
      }
      break;
    case 14: // ARCHIVE with the mule focused
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL05_1;
      }else if(keyCode == LEFT){
        mode = MODE_SNOWBALL04_4;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL03_1;
      }
      break;
    case 15: // SAVE... screen with TO ARCHIVE focused
      if(keyCode == RIGHT){
        mode = MODE_SNOWBALL05_2;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL04_1;
      }
      break;
    case 16: // SAVE... screen with AS SNOWBALL ATTACK focused
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL06;
      }else if(keyCode == LEFT){
        mode = MODE_SNOWBALL05_1;
      }else if(keyCode == -6){
        mode = MODE_SNOWBALL04_1;
      }
      break;
    // shows the SETTING... screen
    // Case 17 needs no interaction, it's just a passage
    // from a screen to another with a delay in between,
    // so is entirely managed by the drawScreen funtion.
    // See the drawScreen funtcion for details.
    case 18: // shows the COMPLETED! screen
      if((keyCode == FIRE) | (keyCode == -7)){
        mode = MODE_SNOWBALL00;
      }
      break;
  }

}
